// Acq1Dlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "Acq1Dlg.h"
#include "Bkdoc.h"
#include "Instek.h"
#include "Regres.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAcq1Dlg dialog
CAcq1Dlg::CAcq1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcq1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcq1Dlg)
	m_sTexte = _T("");
	m_OKRef1 = FALSE;
	m_OKRef2 = FALSE;
	m_OKVoie1 = FALSE;
	m_OKVoie2 = FALSE;
	//}}AFX_DATA_INIT
}
void CAcq1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcq1Dlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDACQUERIR, m_btnAcq);
	DDX_Text(pDX, IDC_STATIC_INFO_ACQ, m_sTexte);
	DDX_Check(pDX, IDC_REF1, m_OKRef1);
	DDX_Check(pDX, IDC_REF2, m_OKRef2);
	DDX_Check(pDX, IDC_VOIE1, m_OKVoie1);
	DDX_Check(pDX, IDC_VOIE2, m_OKVoie2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcq1Dlg, CDialog)
	//{{AFX_MSG_MAP(CAcq1Dlg)
	ON_BN_CLICKED(IDACQUERIR, OnAcquerir)
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_BN_CLICKED(IDC_VOIE1, OnVoie1)
	ON_BN_CLICKED(IDC_VOIE2, OnVoie2)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAcq1Dlg message handlers
void CAcq1Dlg::GestionBoutons(void)
{
	short nb=0;
	if (m_OKVoie1) GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
	if (m_OKVoie2) GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
	if (m_OKVoie1) nb++;
	if (m_OKVoie2) nb++;
	if (m_OKRef1) nb++;
	if (m_OKRef2) nb++;
	if (nb>1)
	{
		if (!m_OKVoie1) GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);
		if (!m_OKVoie2) GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
		if (!m_OKRef1) GetDlgItem(IDC_REF1)->EnableWindow(FALSE);
		if (!m_OKRef2) GetDlgItem(IDC_REF2)->EnableWindow(FALSE);
	}
	if (!m_OKVoie1 && !m_OKVoie2 && !m_OKRef1 && !m_OKRef2)	
		m_btnAcq.EnableWindow(FALSE);
	else
	if (m_ok)
		m_btnAcq.EnableWindow(TRUE);
}
//________________________________________
BOOL CAcq1Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	//Informations concernant l'acquisition
	m_pDoc->m_sTab.RemoveAll();
	m_pDoc->m_sTab.Add("ACQ. OSCILLOSCOPE GW INSTEK");
	m_pDoc->m_sTab.Add("Nom(s)/Prnom(s):");
	m_pInstek=new CInstek(m_pDoc->m_radioPortSerie);

	if (m_pDoc->m_iTypeAcq&1) m_OKVoie1=TRUE;
	if (m_pDoc->m_iTypeAcq&2) m_OKVoie2=TRUE;
	if (m_pDoc->m_iTypeAcq&4) m_OKRef1=TRUE;
	if (m_pDoc->m_iTypeAcq&8) m_OKRef2=TRUE;
	m_sTexte="Slectionner les voies d'acquisition, puis cliquer sur Acqurir.";
	GestionBoutons();
	//Paramtres courants de l'oscillo
	m_ok=m_pInstek->WriteCom(":TIMebase:SCALe?\n:CHANNEL1:SCALE?\n:CHANNEL2:SCALE?\n:MEASURE:SOURce 1\n:MEASURE:VMAX?\n:MEASure:SOURce 2\n:MEASure:VMAX?\n");
	if (m_ok)
	{
		m_iNb=0;SetTimer(10,10,NULL);
	}
	else
	{
		m_sTexte.Format("Erreur d'criture sur le port srie n%d !",m_pDoc->m_radioPortSerie+1);
		m_btnAcq.EnableWindow(FALSE);
		GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);         
		GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);         
		GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
		GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
	}
	UpdateData(FALSE);
	m_btnAcq.EnableWindow(FALSE);
	return TRUE;
}
//________________________________________
void CAcq1Dlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CAcq1Dlg::OnCancel() 
{
	delete m_pInstek;
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//________________________________________
void CAcq1Dlg::OnAcquerir() 
{
	BOOL ok;
	CString s,s1;
	UpdateData(TRUE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(FALSE);
	GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
         
	//En fonction de la voie d'acquisition...
	m_pDoc->m_iTypeGr=0;
	m_pDoc->m_iTypeAcq=0;
	m_iAcq=0;
	m_iCol=0;

	if (m_OKVoie1)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+1;
		m_iAcq=m_iAcq+1;
	}
	if (m_OKVoie2)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+2;
		m_iAcq=m_iAcq+2;
	}
	if (m_OKRef1)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+4;
		m_iAcq=m_iAcq+4;
	}
	if (m_OKRef2)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+8;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+8;
		m_iAcq=m_iAcq+8;
	}

	//On supprime le fichier existant
	//CFile::Remove("bk.$$$");

	m_iNb=0;SetTimer(0,10,NULL);
}
//________________________________________
void CAcq1Dlg::OnRef1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcq1Dlg::OnRef2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcq1Dlg::OnVoie1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcq1Dlg::OnVoie2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcq1Dlg::OnTimer(UINT nIDEvent) 
{
	CString s,s1;
	int i;
	short pos;
	float r;
	switch (nIDEvent)
	{
		case 0:
			//Dtermination voie
			KillTimer(0);
			if (m_iAcq==0)
			{
				//Les acquisitions sont termines
				m_sTexte.Format("Fin d'acquisition.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,m_pDoc->m_iNbCar);
				m_btnCancel.EnableWindow(TRUE);
				m_btnAcq.EnableWindow(TRUE);
				if (m_OKVoie1) GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
				if (m_OKVoie2) GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
				GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
				GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
				GestionBoutons();
				UpdateData(FALSE);
				//On invalide le trac des rgressions
				m_pDoc->m_pReg->Invalider();
				m_pDoc->UpdateAllViews(NULL);
			}
			else
			if (m_iAcq&1)
			{
				//Voie 1
				m_iAcq=m_iAcq-1;
				m_sVoie="CH1";

				//m_pInstek->WriteCom(":ACQuire:MODe0\n");

				s.Format(":ACQuire1:POINt\n");
				m_pInstek->WriteCom(s);
				
				m_pDoc->m_iNbCar=0;
				m_iNb=0;SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&2)
			{
				//Voie 2
				m_sVoie="CH2";
				m_iAcq=m_iAcq-2;

				//m_pInstek->WriteCom(":ACQuire:MODe0\n");

				s.Format(":ACQuire2:POINt\n");
				m_pInstek->WriteCom(s);
				
				m_pDoc->m_iNbCar=0;
				m_iNb=0;SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&4)
			{
				//MEM1
				m_sVoie="REF1";
				m_iAcq=m_iAcq-4;

				//Mmoire 5000 points
				//m_pInstek->WriteCom(":ACQuire:MODe0\n");
				m_pInstek->WriteCom(":ACQuire:LENGth3\n");
				m_pInstek->WriteCom(":ACQuire1:MEMory?\n");
				
				m_pDoc->m_iNbCar=0;
				m_iNb=0;SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&8)
			{
				//MEM2
				m_sVoie="REF2";
				m_iAcq=m_iAcq-8;
				//Mmoire 5000 points
				//m_pInstek->WriteCom(":ACQuire:MODe0\n");
				m_pInstek->WriteCom(":ACQuire:LENGth 3\n");
				m_pInstek->WriteCom(":ACQuire2:MEMory?\n");
				
				m_pDoc->m_iNbCar=0;
				m_iNb=0;SetTimer(2,10,NULL);
			}
		break;
		case 2://Analyse des donnes voies 1 et 2
			if (m_pDoc->m_OKOuvert)
			{
				//L'acquisition est en cours, on attend
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>50)
				{
					KillTimer(2);
					//On traite le contenu du fichier bk.$$$
					if (m_sVoie=="CH1")
						Analyse_buffer(m_iCol,m_iCol+1,m_pInstek->m_xincr,m_pInstek->m_ymult1);
					else
						Analyse_buffer(m_iCol,m_iCol+1,m_pInstek->m_xincr,m_pInstek->m_ymult2);
					m_iCol=m_iCol+2;
					SetTimer(0,10,NULL);
				}
			}
		break;
		case 3://Analyse des donnes mmoires 1 et 2
			if (m_pDoc->m_OKOuvert)
			{
				//L'acquisition est en cours, on attend
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>50)
				{
					KillTimer(3);
					//On traite le contenu du fichier bk.$$$
					Analyse_buffer1(m_iCol,m_iCol+1,m_pInstek->m_xincr,m_pInstek->m_ymult1);
					m_iCol=m_iCol+2;
					SetTimer(0,10,NULL);
				}
			}
		break;
		//____________________________________
		case 10://Lecture paramtres
			if (m_pDoc->m_OKOuvert)
			{
				//L'acquisition est en cours, on attend
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>10)//100 ms
				{
					KillTimer(10);
					//On lit le buffer
					s=m_pInstek->Renvoi_buffer();
					if (s.GetLength()<2)
					{
						m_sTexte="Erreur de communication avec oscilloscope GW Instek !";
						m_btnAcq.EnableWindow(FALSE);
						GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);         
						GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);         
						GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
						GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
					}
					else
					{
						//On peut rechercher un mot dans le buffer, et extraire les caractres jusqu' renconter ; ou \n
						//s1=Extraction(s,"SCALe",&pos);
						//On peut aussi simplement extraire les caractres jusqu' fin de ligne
						//BASE DE TEMPS
						pos=0;
						s1=Extraction(s,"",&pos);
						//AfxMessageBox(s1);
						m_pInstek->m_xincr=ExtractionFloat(s1);
						if (s1.Find("ms")>=0)	m_pInstek->m_xincr=m_pInstek->m_xincr/1000;
						if (s1.Find("us")>=0)	m_pInstek->m_xincr=m_pInstek->m_xincr/1e6;
						//CString z;z.Format("%f",m_pInstek->m_xincr);AfxMessageBox(z);
						//ECHELLE VOIE 1
						s1=Extraction(s,"",&pos);
						m_pInstek->m_ymult1=ExtractionFloat(s1);
						if (s1.Find("mV")>=0)	m_pInstek->m_ymult1=m_pInstek->m_ymult1/1000;
						if (s1.Find("uV")>=0)	m_pInstek->m_ymult1=m_pInstek->m_ymult1/1e6;
						//ECHELLE VOIE 2
						s1=Extraction(s,"",&pos);
						m_pInstek->m_ymult2=ExtractionFloat(s1);
						if (s1.Find("mV")>=0)	m_pInstek->m_ymult2=m_pInstek->m_ymult2/1000;
						if (s1.Find("uV")>=0)	m_pInstek->m_ymult2=m_pInstek->m_ymult2/1e6;
						//EXTRACTION VMAX voie 1 pour savoir si channel ON ou OFF
						s1=Extraction(s,"",&pos);
						if (s1.Find("chan off")>=0)
						{
							//Voie non slectionne sur l'oscilloscope
							m_OKVoie1=FALSE;
							GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);
						}
						else
							m_btnAcq.EnableWindow(TRUE);
						//EXTRACTION VMAX voie 2 pour savoir si channel ON ou OFF
						s1=Extraction(s,"",&pos);
						if (s1.Find("chan off")>=0)
						{
							//Voie non slectionne sur l'oscilloscope
							m_OKVoie2=FALSE;
							GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
						}
						else
							m_btnAcq.EnableWindow(TRUE);
						m_sTexte.Format("Base de temps (s): %1.1e\nCalibre voie 1 (V): %1.1e\nCalibre voie 2 (V): %1.1e",m_pInstek->m_xincr,m_pInstek->m_ymult1,m_pInstek->m_ymult2);
					}
				}
			}
			UpdateData(FALSE);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
CString CAcq1Dlg::Extraction(CString buffer,CString s,short *pos) 
{
	CString s1,s2;
	s1.Format("%102s"," ");

	short p,i,j;
	unsigned char c;
	
	//AfxMessageBox(buffer);
	if (s.GetLength()!=0)
	{
		//Extraction chane  partir de p
		s2=buffer.Right(buffer.GetLength()-*pos);
		p=s2.Find(s);
	}
	else
		p=0;

	//CString z;z.Format("%s\n%d",s,p);
	//AfxMessageBox(z);

	if (p<0)
		s1="";
	else
	{
		//Extraction sous-chane jusqu'au ;
		i=*pos+p+s.GetLength();
		//CString z;z.Format("%d, %d",i,buffer.GetLength());
		//AfxMessageBox(z);
		j=0;
		do
		{
			if (i<buffer.GetLength())
				c=buffer.GetAt(i);
			else
				c='\n';

			if (c!=';' && c!='\n')
			{
				if (j<100) 
				{
					s1.SetAt(j,c);s1.SetAt(j+1,'\0');
					j++;
				}
			}
			i++;
		}
		while (c!=';' && c!='\n' && i<buffer.GetLength());
		*pos=i;
	}
	return s1;	
}
//________________________________________
float CAcq1Dlg::ExtractionFloat(CString s) 
{
	CString s1;
	int i,j;
	unsigned char c;
	s1.Format("%50s"," ");
	float r=1e10;
	//On isole les nombres
	j=0;
	for (i=0;i<s.GetLength();i++)
	{
		c=s.GetAt(i);
		if ((c>=48 && c<=57) || c=='.' || c=='+'|| c=='-')
		{
			s1.SetAt(j,c);j++;s1.SetAt(j,'\0');
		}  
	}
	if (s1.GetLength()>0)
	{
		i=sscanf(s1,"%f",&r);
		if (i==0) r=1e10;
	}
	return r;
}
//________________________________________
void CAcq1Dlg::Analyse_buffer(char col1, char col2,float xincr,float ymult)
{
	//Analyse du contenu du fichier bk.$$$ pour acquisitions voies 1 et 2
	short 
		k,nbo,i,j,nb,k1,k2;
	unsigned char octet,C[1],c;
	char PF,pf;
	CString z;

	//On regarde si le fichier bk.$$$ existe, si oui on l'analyse
	BOOL 
		ok;
	CFileException p_Error;
	ok=m_pDoc->m_Fic.Open("bk.$$$",CFile::modeRead,&p_Error);
	if (ok)
	{
		//Taille du fichier
		m_pDoc->m_iNbCar=m_pDoc->m_Fic.GetLength();
		nb=0;
		for (i=0;i<m_pDoc->m_Fic.GetLength();i++)
		{
			m_pDoc->m_Fic.Read(C,1);
			//IMPORTANT: octet contient l'image numrique du caractre. Ex : c=C[0]='4', alors octet=4
			c=C[0];
			octet=Octet(C[0]);
			if (i==0)
			{
				if (c!='#')
				{
					//Erreur, on arrte
					i=m_pDoc->m_Fic.GetLength();
					AfxMessageBox("Fichier non compatible !");
				}		
			}
			else
			if (i==1)
			{
				nbo=octet;//Typiquement 4 octets: 4 1 0 0 8
				for (j=0;j<nbo;j++)
				{
					m_pDoc->m_Fic.Read(C,1);i++;
				}
			}
			else
			if (i==2+nbo)
			{
				//Base de temps : 4octets
				for (j=0;j<4;j++)
				{
					m_pDoc->m_Fic.Read(C,1);i++;
				}
			}
			else
			if (i==6+nbo)
			{
				//N de la voie (1 octet)
			}
			else
			if (i==7+nbo)
			{
				//3 octets rservs
				for (j=0;j<3;j++)
				{
					m_pDoc->m_Fic.Read(C,1);i++;
				}
				k=0;
			}
			else
			{
				if (k%2==0)
				{
					PF=C[0];
				}
				else
				{
					pf=C[0];
					if (nb<m_pDoc->m_iNbMax)
					{
						if (PF<-100) k1=PF+256; else k1=PF;
						if (pf<-100) k2=pf+256; else k2=pf;
						m_pDoc->m_fT[nb][col1]=nb;
						m_pDoc->m_fT[nb][col2]=k1+k2;
						//m_pDoc->m_fT[nb][col2]=PF;

						//Elimination point abberrant
						if (nb>2)
						{
							if (m_pDoc->m_fT[nb][col2]!=0 && m_pDoc->m_fT[nb-1][col2]==0 && m_pDoc->m_fT[nb-2][col2]!=0 )
							{
								//Le point du milieu est aberrant
								m_pDoc->m_fT[nb-1][col2]=m_pDoc->m_fT[nb-2][col2];
							}
						}

						nb++;
					}
				}
				k++;
			}
		}
		m_pDoc->m_Fic.Close();
		//Mise  l'chelle
		//z.Format("xincr:%f\nymult:%f\n%d, %d",xincr,ymult,col1,col2);AfxMessageBox(z);
		float r=ymult*8;
		//200 pixels = 8 carreaux scop = ymult*8 V = r V
		for (i=0;i<nb;i++)
		{
			if (m_pDoc->m_fT[i][col1]!=1e10 && m_pDoc->m_fT[i][col2]!=1e10)
			{
				m_pDoc->m_fT[i][col1]=m_pDoc->m_fT[i][col1]*xincr/25;
				m_pDoc->m_fT[i][col2]=1.0*r*m_pDoc->m_fT[i][col2]/200;
			}
		}
		m_pDoc->m_iNb=nb;
		//On annule un zoom ventuel
		//Pointeur sur le document en SDI
		/*
		if (AfxGetApp()->m_pMainWnd)
		{
			CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
			CBkView *pView=(CBkView*)pFrame-> GetActiveView();
			//pView->InitZoom();
		}
		*/
		m_pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CAcq1Dlg::Analyse_buffer1(char col1, char col2,float xincr,float ymult)
{
	//Analyse du contenu du fichier bk.$$$ pour acquisitions mmoires 1 et 2
	short 
		k,nbo,i,j,nb;
	unsigned char octet,C[1],c,pf;
	char PF/*,pf*/;
	CString z;

	//On regarde si le fichier bk.$$$ existe, si oui on l'analyse
	BOOL 
		ok;
	CFileException p_Error;
	ok=m_pDoc->m_Fic.Open("bk.$$$",CFile::modeRead,&p_Error);
	if (ok)
	{
		//Taille du fichier
		m_pDoc->m_iNbCar=m_pDoc->m_Fic.GetLength();
		nb=0;
		for (i=0;i<m_pDoc->m_Fic.GetLength();i++)
		{
			m_pDoc->m_Fic.Read(C,1);
			//IMPORTANT: octet contient l'image numrique du caractre. Ex : c=C[0]='4', alors octet=4
			c=C[0];
			octet=Octet(C[0]);
			if (i==0)
			{
				if (c!='#')
				{
					//Erreur, on arrte
					i=m_pDoc->m_Fic.GetLength();
					AfxMessageBox("Fichier non compatible !");
				}		
			}
			else
			if (i==1)
			{
				//15 octets sans intrt
				for (j=0;j<15;j++)
				{
					m_pDoc->m_Fic.Read(C,1);i++;
				}
				k=0;
			}
			else
			{
				//Mesures
				if (k%2==0)
				{
					PF=C[0];
				}
				else
				{
					pf=C[0];
					if (nb<m_pDoc->m_iNbMax)
					{
						m_pDoc->m_fT[nb][col1]=nb;
						//pf non utilis !!!
						m_pDoc->m_fT[nb][col2]=PF;
						nb++;
					}
				}
				k++;
			}
		}
		m_pDoc->m_Fic.Close();
		//Mise  l'chelle
		//z.Format("xincr:%f\nymult:%f\n%d, %d",xincr,ymult,col1,col2);AfxMessageBox(z);
		float r=ymult*8;//Nb. volt/carreau * 8 carreaux
		for (i=0;i<nb;i++)
		{
			if (m_pDoc->m_fT[i][col1]!=1e10 && m_pDoc->m_fT[i][col2]!=1e10)
			{
				m_pDoc->m_fT[i][col1]=m_pDoc->m_fT[i][col1]*xincr;
				m_pDoc->m_fT[i][col2]=m_pDoc->m_fT[i][col2]*r/200;
			}
		}
		m_pDoc->m_iNb=nb;
		//On annule un zoom ventuel
		//Pointeur sur le document en SDI
		/*
		if (AfxGetApp()->m_pMainWnd)
		{
			CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
			CBkView *pView=(CBkView*)pFrame-> GetActiveView();
			//pView->InitZoom();
		}
		*/
		m_pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
unsigned char CAcq1Dlg::Octet(unsigned char c)
{
	unsigned char k;
	int i;
	CString s;
	s.Format("%c",c);
	i=sscanf(s,"%d",&k);
	if (i==1)
		return k;
	else
		return 0;
}
