// BkDoc.cpp : implementation of the CBkDoc class
//
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Demardlg.h"
#include "Regres.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pApp=(CBkApp*)AfxGetApp();
	m_pApp->m_pDoc=this;
	//Nom fichiers par dfaut
	m_sNomFic="SansNom.tek";
	m_sNomFicTxt="SansNom.txt";
	//Limites
	m_fXmi=0;
	m_fYmi=0;
	m_fXma=270;
	m_fYma=190;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1; 
	//Textes
	m_fHautTexte=4.5;
	m_fCoefTexte=1.0;
	//Port srie
	m_radioPortSerie=0;	//COM1 par dfaut
	//Voies d'acquisition
  m_iTypeAcq=1;			//1:CH1, 2:CH2, 4:REF1, 8:REF2, 16:MATH
	//Acquisition
  m_iNbMax=2500;		//2500 acquisitions maxi
  m_iNb=0;					//Aucune acquisition de faite pour l'instant
  m_fT=new float[m_iNbMax][6];
	//Initialisation tableau
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<6;j++)
		{
			m_fT[i][j]=1e10;
		}
	}
	//Rgressions polynomiales_______________________
	m_pReg=new CRegres();
	m_OKReg=FALSE;
	//Zoom et tracker_________________________________
	m_OKZoom=FALSE;
	InitZoom();
	m_tracker.m_rect.left=0;
	m_tracker.m_rect.top=0;
	m_tracker.m_rect.right=1;
	m_tracker.m_rect.bottom=1;
	//Rflectomtrie__________________________________
	m_fIndice=1.475;					//Indice fibre
	m_fURef=0;								//URef
	//Vlocimtrie____________________________________
	m_fInterFr=7;							//Interfrange en m
	m_fFreq=8;								//Frq. signal Doppler en kHz
	m_fDuree=4;								//Dure du signal Doppler en ms
	m_radioFFT=0;							//FFT=f(Frq) par dfaut 
	
	for (i=0;i<2;i++)     //Initialisation des paramtres
	{
		m_fAmplitude[i]=1e10;	
		m_fCrms[i]=1e10;	
		m_fMean[i]=1e10;	
		m_fFrequence[i]=1e10;
	}
	m_OKPara=FALSE;
	//Graphes_________________________________________
	m_iTypeGr=-1;	//(0: , 1:CH1, 2:CH2, 4:REF1, 8:REF2, 16:MATH, 32:AT., 64:FREQ., 128:VIT.)
	//Infos zone de liste
	m_OKinfo=FALSE; 						//Affichage des infos par dfaut
	m_sTab.RemoveAll();
	m_sTab.Add("ACQ. OSCILLOSCOPE TEKTRONIX");
	m_sTab.Add("Nom(s)/Prnom(s):");
	m_fXinfo=80;							//Position d'criture par dfaut
	m_fYinfo=90;

	//Nom de fichier sur ligne de commande
  CWinApp *p=AfxGetApp();
  //AfxMessageBox(p->m_lpCmdLine);
	CString s1=p->m_lpCmdLine;
	s1.MakeLower();
	if (s1.Right(4)==".tek") 
	{
		m_sNomFic=s1;   
		//Lecture du fichier .tek
		OnOpenDocument(s1);
  }
	//Marque de pointage______________________________
	m_OKAccro=TRUE;

	//Fichier bk.$$$________________________
	m_iNbCar=0;
	m_OKOuvert=FALSE;

	//Boite de dialogue au dmarrage__________________
	/*
	CDemarDlg* m_pDemDlg;
	m_pDemDlg=new CDemarDlg();
	Sleep(3000);
	m_pDemDlg->DestroyWindow();
	delete m_pDemDlg;
	*/
}
//__________________________________________________
CBkDoc::~CBkDoc()
{
	delete[] m_fT;
	delete m_pReg;
}
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	CString s;
  //Suppression extension
  s=m_sNomFic.Mid(0,m_sNomFic.GetLength()-4);
  //Suppression chemin
  int i=s.GetLength();
  do
  {    
  	i--;
  }
  while (i>=0 && s.GetAt(i)!='\\' && s.GetAt(i)!=':');
  if (i!=0) s=s.Mid(i+1,s.GetLength());
	//En minuscules
	s.MakeLower();
	//1er caractre en majuscules
	s.SetAt(0,toupper(s.GetAt(0)));	
	SetTitle(s);
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;
	CString s;
	if (ar.IsStoring())
	{
		//ECRITURE
		ar << (short)m_iNbMax;
		ar << (short)m_iNb;           
		ar << m_fHautTexte;
		ar << m_fCoefTexte;
		ar <<	(short)m_iTypeGr;
		ar <<	(short)m_iTypeAcq;
		for (i=0;i<m_iNb;i++)
		{
			ar << m_fT[i][0];
			ar << m_fT[i][1];
			ar << m_fT[i][2];
			ar << m_fT[i][3];
			ar << m_fT[i][4];
			ar << m_fT[i][5];
		}
		//Srialisation infos
		ar << (short)m_sTab.GetSize();
		for (i=0;i<m_sTab.GetSize();i++)
		{  
			ar << m_sTab.GetAt(i);
		}
		ar << m_fXinfo;
		ar << m_fYinfo;
		//Rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar << m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar << m_pReg->m_fP1[i][j];
				ar << m_pReg->m_fP2[i][j];
				ar << (short)m_pReg->m_iNoColX[i][j];
				ar << (short)m_pReg->m_iNoColY[i][j];
		 		ar << (short)m_pReg->m_iNoPt[i][j];
				ar << (short)m_pReg->m_OKPt[i][j];
			}
	 		ar << (short)m_pReg->m_iNoBtn[i];
			ar << (short)m_pReg->m_iType[i];
	 		ar << (short)m_pReg->m_OKCalcul[i];
	 		ar << (short)m_pReg->m_OKTrace[i];
		}
		//Autres paramtres
		ar << m_fIndice;
		ar << m_fURef;
		ar << m_fInterFr;
		ar << m_fFreq;
		ar << m_fDuree;
	}
	else
	{
		//LECTURE
		//Pas de marque de pointage, pas de coordonnes relatives
		CBkApp* pApp=(CBkApp*)AfxGetApp();
		pApp->m_fDx=0;
		pApp->m_fDy=0;
		InitZoom();
		/**/
		ar >> (short&)m_iNbMax;
		ar >> (short&)m_iNb;
		ar >> m_fHautTexte;
		ar >> m_fCoefTexte;
		ar >>	(short&)m_iTypeGr;
		ar >>	(short&)m_iTypeAcq;
    for (i=0;i<m_iNb;i++)
		{
			ar >> m_fT[i][0];
			ar >> m_fT[i][1];
			ar >> m_fT[i][2];
			ar >> m_fT[i][3];
			ar >> m_fT[i][4];
			ar >> m_fT[i][5];
		}                    
		//Srialisation infos  
		m_sTab.RemoveAll();
		ar >> (short&)j;
		for (i=0;i<j;i++)
		{  
			ar >>s; 
			m_sTab.Add(s);
		} 
		ar >> m_fXinfo;
		ar >> m_fYinfo;
		//Rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar >> m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar >> m_pReg->m_fP1[i][j];
				ar >> m_pReg->m_fP2[i][j];
				ar >> (short&)m_pReg->m_iNoColX[i][j];
				ar >> (short&)m_pReg->m_iNoColY[i][j];
		 		ar >> (short&)m_pReg->m_iNoPt[i][j];
				ar >> (short&)m_pReg->m_OKPt[i][j];
			}
	 		ar >> (short&)m_pReg->m_iNoBtn[i];
			ar >> (short&)m_pReg->m_iType[i];
	 		ar >> (short&)m_pReg->m_OKCalcul[i];
	 		ar >> (short&)m_pReg->m_OKTrace[i];
		}
		//Autres paramtres
		ar >> m_fIndice;
		ar >> m_fURef;
		ar >> m_fInterFr;
		ar >> m_fFreq;
		ar >> m_fDuree;
		/**/
		/*
		//Ancien format...
		long l;
		m_iTypeAcq=1;
		ar >> (short&)m_iNbMax;
		m_iNbMax=2500;
		ar >> (short&)m_iNb;
		ar >> (short&)i;
		ar >> (short&)i;
		ar >> m_fHautTexte;
		ar >> m_fCoefTexte;

		ar >>	(short&)i;	//Supprim le 23/01/01
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)m_radioVoieAcq;
		ar >>	(short&)m_iTypeGr;
		m_iTypeGr=1;
		ar >>	(long&)l;		//Supprim  
		ar >> m_fIndice;
		ar >>	m_fXincr;
		ar >>	m_fPtOff;
		ar >>	m_fInterFr;
		ar >>	(short&)m_radioFFT;
    for (i=0;i<m_iNb;i++)
		{
			ar >> m_fT[i][0];
			ar >> m_fT[i][1];
			ar >> m_fT[i][2];
			ar >> m_fT[i][3];
		}                    
		//Srialisation infos  
		m_sTab.RemoveAll();
		ar >> (short&)j;
		for (i=0;i<j;i++)
		{  
			ar >>s; 
			m_sTab.Add(s);
		} 
		ar >> m_fXinfo;
		ar >> m_fYinfo;
		*/
	}	
}
/////////////////////////////////////////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
/////////////////////////////////////////////////////////////////////////////
// CBkDoc commands
void CBkDoc::ColonnesTableau(short NoGr, short *ColT,short *ColU)
{
	//Recherche des colonnes t(s) et u(V) du tableau
	switch (NoGr)
	{
		case 1://CH1
			*ColT=0;*ColU=1;
		break;
		case 2://CH2
			if (m_iTypeAcq & 1)
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 4://REF1
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 8://REF2
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2)|| (m_iTypeAcq & 4))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 16://MATH
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2)|| (m_iTypeAcq & 4)|| (m_iTypeAcq & 8))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		default://Rtro ou vlo
			*ColT=4;*ColU=5;
		break;
	}
}
//__________________________________________________
void CBkDoc::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//__________________________________________________
void CBkDoc::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//________________________________________
CString CBkDoc::Renvoie_buffer(void)
{
	//Analyse du contenu du fichier bk.$$$
	short 
		i;
	CString s;
	unsigned char C[1];

	s.Format("%1000s"," ");
	//On regarde si le fichier bk.$$$ existe, si oui on l'analyse
	BOOL 
		ok;
	CFileException p_Error;
	ok=m_Fic.Open("bk.$$$",CFile::modeRead,&p_Error);
	if (ok)
	{
		//Taille du fichier
		m_iNbCar=m_Fic.GetLength();
		//s.Format("%d",m_iNbCar);AfxMessageBox(s);
		m_iNb=0;
		for (i=0;i<m_iNbCar;i++)
		{
			m_Fic.Read(C,1);
			if (i<999)
			{
				s.SetAt(i,C[0]);
				s.SetAt(i+1,'\0');
			}
		}
		if (m_iNbCar==0) s="";
		//AfxMessageBox(s);
		m_Fic.Close();
	}
	else
		s="";
	return s;
}