//Classe CDessin
#include "stdafx.h"
#include "bk.h"
#include "Dessin.h"
#include "BkDoc.h"
#include "Regres.h"
#include <math.h>
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//___________________________________________________
CDessin::CDessin(class CDC* pDC,class CBkDoc* pDoc,float f_ech)
{                       
	m_ech=f_ech;
	m_pDC=pDC;
	m_pDoc=pDoc;
	m_fHautTexte=m_pDoc->m_fHautTexte*m_pDoc->m_fCoefTexte;//Hauteur rfrence du texte en mm
	echx=1;
	echy=1;
	xori=0;
	yori=0;
	factx=1;
	facty=1;
	xmi=m_pDoc->m_fXmi;
	ymi=m_pDoc->m_fYmi;
	xma=m_pDoc->m_fXma;
	yma=m_pDoc->m_fYma;  
	//Pour trac graphes...
	if (m_pDoc->m_iNb>0)
	{
		Nb=m_pDoc->m_iNb;
		fT=m_pDoc->m_fT;
		
		//Initialisation des graphes  tracer et des noms abs/ord
		for (short i=0;i<6;i++)
		{
			for (short j=0;j<2;j++)
			{
				iD_Axes[j][i]=-1;
				iN_Axes[j][i]="";
			}
		}
	}
	//Pas de zoom par dfaut
	InitZoom();
}
//__________________________________________________
CDessin::~CDessin()
{
	//Mise  jour des paramtres de trac
	if (m_pDoc->m_iNb>0)
	{
		m_pDoc->m_fXmi=xmi;	
		m_pDoc->m_fYmi=ymi;	
		m_pDoc->m_fXma=xma;	
		m_pDoc->m_fYma=yma;	
		//Mise  jour des chelles pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fEchx=echx;	
		m_pDoc->m_fEchy=echy;	
		//Mise  jour du dcalage d'origine pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fXori=xori;	
		m_pDoc->m_fYori=yori;	
		//Mise  jour du fact. puissance de 10 pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fFactx=factx;	
		m_pDoc->m_fFacty=facty;	 
	}
}
//__________________________________________________
void CDessin::Absisse(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>5) NoGraphe=0;
	if (Col<0 || Col>5) Col=0;
	iD_Axes[0][NoGraphe]=Col;
	iN_Axes[0][NoGraphe]=s;
}
//__________________________________________________
void CDessin::Ordonnee(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>5) NoGraphe=0;
	if (Col<0 || Col>5) Col=0;
	iD_Axes[1][NoGraphe]=Col;
	iN_Axes[1][NoGraphe]=s;
}
//__________________________________________________
void CDessin::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//__________________________________________________
void CDessin::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//__________________________________________________
void CDessin::ligne(float f_xd,float f_yd,float f_xa,float f_ya)
{
	m_pDC->MoveTo((int)(f_xd*m_ech),(int)(f_yd*m_ech));
	m_pDC->LineTo((int)(f_xa*m_ech),(int)(f_ya*m_ech));
}
//__________________________________________________
void CDessin::cercle(float f_xc,float f_yc,float f_ray)
{
  int
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((f_xc-f_ray)*m_ech);	
  y1=(int)((f_yc+f_ray)*m_ech);	
  x2=(int)((f_xc+f_ray)*m_ech);	
  y2=(int)((f_yc-f_ray)*m_ech);	
  x3=(int)((f_xc-f_ray)*m_ech);	
  y3=(int)((f_yc)*m_ech);	
  x4=(int)((f_xc-f_ray)*m_ech);	
  y4=(int)((f_yc)*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//__________________________________________________
void CDessin::texte(float f_x,float f_y,CString s)
{
	m_pDC->TextOut((int)(f_x*m_ech),(int)(f_y*m_ech),s);     
}
//__________________________________________________
void CDessin::ecritInfo(float f_x,float f_y,CStringArray *p_sTab,long coul)
{
	CFont 
		fntI,
		*m_pOldFont;
	COLORREF clrOld;
			
	fntI.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntI);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	clrOld=m_pDC->SetTextColor(coul);
	//Dtermination de l'interligne
	TEXTMETRIC tm;
	m_pDC->GetTextMetrics(&tm);
	int nCyInterval=tm.tmHeight+tm.tmExternalLeading;    

	CString s;	
  int y=(int)(f_y*m_ech);
  for (int i=0;i<p_sTab->GetSize();i++)
  {
   	s=p_sTab->GetAt(i);
		m_pDC->TextOut((int)(f_x*m_ech),y,s);     
   	y=y-nCyInterval;   
  }

	m_pDC->SelectObject(m_pOldFont);	  
  fntI.DeleteObject();            
  m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::barre(float f_xg,float f_yb,float f_xd,float f_yh)
{
	CRgn Region;
	Region.CreateRectRgn((int)(f_xg*m_ech),(int)(f_yb*m_ech),(int)(f_xd*m_ech),(int)(f_yh*m_ech));
	m_pDC->PaintRgn(&Region);
	Region.DeleteObject();
}
//__________________________________________________
void CDessin::cadre(float f_xg,float f_yb,float f_xd,float f_yh)
{
	ligne(f_xg,f_yb,f_xd,f_yb);	
	ligne(f_xd,f_yb,f_xd,f_yh);	
	ligne(f_xd,f_yh,f_xg,f_yh);	
	ligne(f_xg,f_yh,f_xg,f_yb);	
}   
//__________________________________________________
void CDessin::fleche(float f_xp,float f_yp,float f_a,float f_l)
{
  const 
  	float M_PI=(float)(4*atan(1)),
  	ang=(float)(15.0*M_PI/180);
  f_a=f_a+M_PI;
  ligne(f_xp,f_yp,(float)(f_xp + f_l*cos(f_a+ang)),(float)(f_yp + f_l*sin(f_a+ang)));
  ligne(f_xp,f_yp,(float)(f_xp + f_l*cos(f_a-ang)),(float)(f_yp + f_l*sin(f_a-ang)));
}
//__________________________________________________
void CDessin::TraceDMC(int no,float a,float b)
{
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;	
	double 
		xd,yd,xa,ya,a1,b1,
		M_PI=3.14159;
	char s[60];	
  
  if (a!=1e10 && b!=1e10)
  {
  	b1=(b-yori)*echy;
		a1=a*echy/echx;
		p2d(-xori*echx,b1,atan(a1),xmi+5,0,M_PI/2,&xd,&yd);
		if (yd>yma-5)	
			p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xd,&yd);
		else
		if (yd<ymi+5)	
			p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xd,&yd);
  
  	p2d(-xori*echx,b1,atan(a1),xma-5,0,M_PI/2,&xa,&ya);
		if (ya>yma-5) 	
			p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xa,&ya);
		else
		if (ya<ymi+5) 
			p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xa,&ya);

  	ligne((float)(xd),(float)(yd),(float)(xa),(float)(ya));
  	//Ecriture n DMC
		fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
		m_pOldFont=m_pDC->SelectObject(&fntD);	  
		m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
		//m_pDC->SetTextAlign(TA_BASELINE);							
		clrOld=m_pDC->SetTextColor(RGB(0,0,0));

  	sprintf(s,"(%d)",no);
  	texte((float)(xd),(float)(yd),s);
  	texte((float)(xa),(float)(ya),s);
  	//Ecriture quation
  	sprintf(s,"DMC %d: y=%1.3ex%-+1.3e",no,a,b);
  	texte(xma-1,(float)(yma-6-(m_fHautTexte+0.5)*no),s);

		m_pDC->SelectObject(m_pOldFont);
		fntD.DeleteObject();                   
		m_pDC->SetTextColor(clrOld);
	}					
}
//__________________________________________________
void CDessin::TraceMarqPoint(float xp1,float yp1,float xp2,float yp2)
{
	xp1=xp1*factx;
	yp1=yp1*facty;
	xp2=xp2*factx;
	yp2=yp2*facty;
	MarqueDePointage(RGB(127,255,127),xp1,yp1);
	MarqueDePointage(RGB(127,255,127),xp2,yp2);
}
//__________________________________________________
void CDessin::MarqueDePointage(unsigned long coul,float x,float y)
{
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);

	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	barre(x-0.8,y-0.8,x+0.8,y+0.8);

	m_pDC->SelectObject(&brosseB);
	barre(x-0.6,y-0.6,x+0.6,y+0.6);


	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
}
//__________________________________________________
void CDessin::MarqueDePointageVal(unsigned long coul,float x,float y)
{
	CString s;
	CFont 
		fntD,
		*m_pOldFont;  
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;
	COLORREF clrOld;	

	fntD.CreateFont((int)(m_ech*m_fHautTexte*0.85),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
 	s.Format("%1.3f, %1.3f",x,y);

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
 	texte(x,y+1.5,s);

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	barre(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	barre(x-0.6,y-0.6,x+0.6,y+0.6);

	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::p2d(double xd1,double yd1,double a1,double xd2,double yd2,double a2,double *p_x,double *p_y)
{
	double
		b1,b2,
		a11,a21;

	a11=cos(a1);a21=cos(a2);
	if ((fabs(a11)<1e-5)&&(fabs(a21)>1e-5))
	{
		//Droite 1 verticale
		b2=yd2-tan(a2)*xd2;
		*p_x=xd1;*p_y=tan(a2)*(*p_x)+b2;
	}
	else
	if ((fabs(a21)<1e-5)&&(fabs(a11)>1e-5))
	{
		//Droite 2 verticale
		b1=yd1-tan(a1)*xd1;
		*p_x=xd2;*p_y=tan(a1)*(*p_x)+b1;
	}
	else
	if (fabs(a11-a21)<1e-8)
	{
		//Droites parallles
		*p_x=1e10;*p_y=1e10;
	}
	else
	{
		b1=yd1-tan(a1)*xd1;
		b2=yd2-tan(a2)*xd2;
		*p_x=(b2-b1)/(tan(a1)-tan(a2));
		*p_y=tan(a1)*(*p_x)+b1;
	}
}
//Version du 12/10/01 avec diffrentes abscisses_____
//Version du 02/01/02 avec zoom______________________
char CDessin::Graphe61(void)
{    
  CPen 
  	plumeC,       
  	plumeD,
  	plumeX,
  	plumeY,
  	plumeM,
  	plumeR,
  	plumeI,
  	plumeJ,
  	*m_pOldPen;
	CFont 
		fntC,  
		fntD,
		*m_pOldFont;
	COLORREF clrOld;	
  
	const float M_PI=(float)(4*atan(1));
  short
  	i,j,k,
		nb[6]={0,0,0,0,0,0}; 
  float
  	r,
  	x,y,xd,yd,xa,ya,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10,
		larg,haut,  //Dimensions de la fenetre
		pasx,pasy;	
	long
		cc[6]={RGB(255,0,0),RGB(0,128,0),RGB(0,0,128),RGB(221,86,13),RGB(255,0,255),RGB(0,0,0)};	
	CString	s;	             
	BOOL ok;		
			
	for(i=0;i<Nb;i++)
	{                    
		for (j=0;j<6;j++)
		{
			//Absisses
			if (iD_Axes[0][j]!=-1 && iD_Axes[1][j]!=-1) 
			{
				//Ce couple abs/ord est  tracer
				if (fT[i][iD_Axes[0][j]]>m_fZoomXmi && fT[i][iD_Axes[0][j]]<m_fZoomXma && fT[i][iD_Axes[1][j]]>m_fZoomYmi && fT[i][iD_Axes[1][j]]<m_fZoomYma) 
				{
					if (fT[i][iD_Axes[0][j]]<xmin) xmin=fT[i][iD_Axes[0][j]];
					if (fT[i][iD_Axes[0][j]]>xmax) xmax=fT[i][iD_Axes[0][j]];
					if (fT[i][iD_Axes[1][j]]<ymin) ymin=fT[i][iD_Axes[1][j]];
					if (fT[i][iD_Axes[1][j]]>ymax) ymax=fT[i][iD_Axes[1][j]];
					nb[j]++;
				}
			}
		}
	}
	ok=FALSE;
	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1 && nb[k]>=2) ok=TRUE;
	}
	if (!ok) return 1;
  
	//s.Format("xmin:%f, xmax:%f",xmin,ymin);AfxMessageBox(s);

	//Calcul des chelles, prvoir ventuellement une marge...
	larg=xma-xmi;
	haut=yma-ymi;
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=(float)(ymax+0.01);
		ymin=(float)(ymin-0.01);
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=(float)(xmax+0.01);
		xmin=(float)(xmin-0.01);
	}                                
	echx=(larg-70)/(xmax-xmin);                    
	echy=(haut-70)/(ymax-ymin);
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
	}                              
	while	(echx*pasx<=1);
	pasx=pasx*10;
	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=1);		
	pasy=pasy*10;
	//Rajustement en fonction du nombre de divisions de l'axe
	i=(int)((xmax-xmin)/pasx);
	if (i<=2) pasx=pasx/4;
	else
	if (i<=5) pasx=pasx/2;
	if (i>12) pasx=pasx*2;

	j=(int)((ymax-ymin)/pasy);
	if (j<=2) pasy=pasy/4;
	else
	if (j<=5) pasy=pasy/2;
	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1);	
	}	                           
	else
		facty=1;
	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
	//Dplacement de l'origine de la fenetre graphique    
	if (xori!=0)
		xmi=-30;		
	else
		xmi=xmin*echx-30;		
	xma=xmi+larg;		
	if (yori!=0)
		ymi=-30;		
	else
		ymi=ymin*echy-30;		
	yma=ymi+haut;
  //Dcalage axes
  m_pDC->SetWindowOrg((int)(m_ech*xmi),(int)(m_ech*yma));
	fntC.CreateFont((int)(m_ech*m_fHautTexte*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntC);	  
	m_pDC->SetTextAlign(TA_LEFT);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  texte((float)(xmi+0.5),(float)(ymi+4.5),"B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS");
	//Date et heure
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	m_pDC->SetTextAlign(TA_RIGHT);							
	texte((float)(xma-0.5),(float)(ymi+4.5),s);

  plumeC.CreatePen(PS_SOLID,(int)(0.20*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeC);        
  cadre(xmi,ymi,xma,yma);
	//Dtermination zone de trac
	xa=pasx;
	while(xa*echx<=(xma-5))
	{
		xa=xa+pasx;
	}
	xa=xa-pasx;
	xa=xa*echx;
	
	xd=-pasx;
	while(xd*echx>=(xmi+5))
	{
		xd=xd-pasx;
	}
	xd=xd+pasx;
	xd=xd*echx;
  ya=pasy;
  while (ya*echy<=(yma-5))
  {                        
  	ya=ya+pasy;
  }     
  ya=ya-pasy;                  
  ya=ya*echy;
  yd=-pasy;
  while (yd*echy>=(ymi+5))
  {                        
  	yd=yd-pasy;
  } 
  yd=yd+pasy;
  yd=yd*echy;
  //Cadre autour de la zone 
  cadre(xd,yd,xa,ya);
	//Trac des axes  
	ligne(xd,0,xa,0);
	ligne(0,yd,0,ya);
  plumeD.CreatePen(PS_SOLID,(int)(0*m_ech),RGB(127,127,127));
	m_pDC->SelectObject(&plumeD);        
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	m_pDC->SetTextColor(RGB(0,0,0));
  //Division axe x
  x=pasx;
  while (x*echx<=(xma-5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	texte(r,-2.5,s);  
  	ligne(r,yd,r,-7.00);
  	ligne(r,0.0,r,ya);
    x=x+pasx;
  }                   
  x=-pasx;
  while (x*echx>=(xmi+5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	texte(r,-2.5,s);  
  	ligne(r,yd,r,-7.00);
  	ligne(r,0.0,r,ya);
    x=x-pasx;
  }                      
	//Division axe y
	m_pDC->SetTextAlign(TA_RIGHT);							
	y=0;
	while(y*echy<=(yma-5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	texte(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) ligne(xd,r,-10,r);
  	ligne(0.0,r,xa,r);
		y=y+pasy;
	}		  
	y=-pasy;
	while(y*echy>=(ymi+5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	texte(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) ligne(xd,r,-10,r);
  	ligne(0.0,r,xa,r);
		y=y-pasy;
	}		                  
	//Ecriture des chelles
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	s.Format("Echx:%7.2e / Echy:%7.2e",echx,echy);
	texte((float)(xd+1.50),(float)(yma-5.00),s);  
	//Ecriture du titre
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_CENTER);							
	texte((float)((xmi+xma)/2),(float)(yma-30.0),titre);  
	//Ecriture facteurs axes x et noms axes abscisses
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
	r=1.0;          
	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[0][k],1/factx);
			texte(xa-1.0,r,s);
			r=r+5.0;
		}
	}

	//Ecriture facteurs axes y et noms axes ordonnes
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	r=ya-5.0;
	for (k=0;k<6;k++)
	{
		if (iD_Axes[1][k]!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[1][k],1/facty);
			texte(3.0,r,s);
			r=r-5.0;
		}
	}
	//Trac graphe                    
  plumeX.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[0]);
  plumeY.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[1]);
  plumeM.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[2]);
  plumeR.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[3]);
  plumeI.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[4]);
  plumeJ.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[5]);

	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1)
		{
			for (i=1;i<Nb;i++)
			{
				xd=fT[i-1][iD_Axes[0][k]];
				yd=fT[i-1][iD_Axes[1][k]];
				xa=fT[i][iD_Axes[0][k]];
				ya=fT[i][iD_Axes[1][k]];
				if (xd>m_fZoomXmi && yd>m_fZoomYmi && xa<m_fZoomXma && ya<m_fZoomYma)
				{
					xd=(xd-xori)*echx;
					yd=(yd-yori)*echy;
					xa=(xa-xori)*echx;
					ya=(ya-yori)*echy;
					switch (k)
					{
						case 0:
							m_pDC->SelectObject(&plumeX);        
						break;
						case 1:
							m_pDC->SelectObject(&plumeY);        
						break;
						case 2:
							m_pDC->SelectObject(&plumeM);        
						break;
						case 3:
							m_pDC->SelectObject(&plumeR);        
						break;
						case 4:
							m_pDC->SelectObject(&plumeI);        
						break;
						case 5:
							m_pDC->SelectObject(&plumeJ);        
						break;
					}
					if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
					{
						ligne(xd,yd,xa,ya);
					}
				}
			}
		}
	}

	m_pDC->SelectObject(m_pOldPen);        
	plumeX.DeleteObject();        
	plumeY.DeleteObject();        
	plumeM.DeleteObject();        
	plumeR.DeleteObject();        
	plumeI.DeleteObject();        
	plumeJ.DeleteObject();        
	plumeC.DeleteObject();        
	plumeD.DeleteObject();                          
	m_pDC->SelectObject(m_pOldFont);        
	fntC.DeleteObject();
	fntD.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return 0;
} 
//__________________________________________________
void CDessin::TraceReg(int no, CRegres *pr)
{
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;	
	double 
		x,y,
		xd,yd,xa,ya,
		M_PI=3.14159;
	short i;
	CString s;	
	CPen
  	plumeR,
  	*m_pOldPen;
  
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,0));
  plumeR.CreatePen(PS_SOLID,(int)(0.40*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeR);        

	//Trac de la rgression polynomiale	
	if (pr->m_fP1[no][0]>pr->m_fP2[no][0])
	{
		//Inversion
		x=pr->m_fP1[no][0];pr->m_fP1[no][0]=pr->m_fP2[no][0];pr->m_fP2[no][0]=x;
		y=pr->m_fP1[no][1];pr->m_fP1[no][1]=pr->m_fP2[no][1];pr->m_fP2[no][1]=y;
	}
	for (x=pr->m_fP1[no][0];x<=pr->m_fP2[no][0];x=x+0.002*(pr->m_fP2[no][0]-pr->m_fP1[no][0]))
	{
		y=pr->m_fa[no][7]*pow(x,7)+pr->m_fa[no][6]*pow(x,6)+pr->m_fa[no][5]*pow(x,5)+pr->m_fa[no][4]*pow(x,4)+pr->m_fa[no][3]*pow(x,3)+pr->m_fa[no][2]*pow(x,2)+pr->m_fa[no][1]*x+pr->m_fa[no][0];
		xa=(x-xori)*echx;
		ya=(y-yori)*echy;
		if ((x!=pr->m_fP1[no][0]) && (xd>xmi+5) && (xd<xma-5) && (yd>ymi+5) && (yd<yma-5) && (xa>xmi+5) && (xa<xma-5) && (ya>ymi+5) && (ya<yma-5))
		{
			ligne((float)(xd),(float)(yd),(float)(xa),(float)(ya));
		}
		
		xd=xa;yd=ya;
	}
	//Ecriture des coefficients
	for (i=0;i<8;i++)
	{
 		if (pr->m_fa[no][i]!=1e10 && pr->m_fa[no][i]!=0)
		{
			s.Format("a%d[%d]=%12.3e",i,no,pr->m_fa[no][i]);
 			texte(xma-50*(no+1),(float)(yma-6-(m_fHautTexte+0.5)*i),s);
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plumeR.DeleteObject();        
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
