// Fft.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Fft.h"
#include <math.h>
//Indicateur de progression standard
#include "progdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CFft
CFft::CFft(float (*T)[2],short *Nb)
{
	m_fT=T;
	n=Nb;                       

	//Boite de dialogue progression__________________
	m_pProg=new CProgDlg();
}
//__________________________________________________
CFft::~CFft()
{
	m_pProg->DestroyWindow();
	delete m_pProg;
}

BEGIN_MESSAGE_MAP(CFft, CWnd)
	//{{AFX_MSG_MAP(CFft)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CFft message handlers
//__________________________________________________
BOOL CFft::CalculFft(void)
{
	CString s;
	const float PI=(float)(4*atan(1));
	
	float
		RealFi,ImagFi,RealT,RealT1,ImagT,ImagT1,RealU,ImagU,RealW,ImagW,RealU1,ImagU1;
	int 
		ln,nm1,k,j,i,
		le,le1,l,ip;
		
	FILE *f_dir;

	f_dir=fopen("FFT.$$$","wb+");
	if (f_dir==NULL)
	{
		AfxMessageBox("Erreur d'criture fichier ""FFT.$$$"" sur disque!");
		return FALSE;
	}	

  //Copier les valeurs en colonne 0( partie R) et 
  //colonne 1 (partie I) dans fichier
  for (i=0;i<(*n);i++)
  {
  	e.RealF=m_fT[i][0];
  	e.ImagF=m_fT[i][1];
  	e_enreg(f_dir,i,&e);
  }
  
	ln=(int)(log10(*n)/log10(2));
	nm1=*n-1;

	//Indicateur de progression, initialisation
	m_pProg->m_progress.SetRange(0,nm1+ln+*n+2);
	//Indicateur de progression, position 1
	m_pProg->m_progress.SetPos(1);


	//Reclasser les chantillons
	k=0;
	for (j=0;j<nm1;j++)
	{

		//Indicateur de progression, position 2
		m_pProg->m_progress.SetPos(1+j);

		i=2;
		while (k>=*n/i && k>0)
		{
			k=k-*n/i;
			i=i+i;
		}
		k=k+*n/i;

		if (k>j)
		{
	  	l_enreg(f_dir,j+1,&e);
	  	RealT=e.RealF;
	  	ImagT=e.ImagF;
	  	l_enreg(f_dir,k,&e);
			RealT1=e.RealF;
	  	ImagT1=e.ImagF;
			
			e.RealF=RealT1;
			e.ImagF=ImagT1;
	  	e_enreg(f_dir,j+1,&e);
			e.RealF=RealT;
			e.ImagF=ImagT;
	  	e_enreg(f_dir,k,&e);
		}
	}
	//FFT ____________________________________________
	le=1;
	for (l=1;l<=ln;l++)
	{
		//Indicateur de progression
		m_pProg->m_progress.SetPos(1+nm1+l);

		le=le+le;
		le1=le/2;
		RealU=(float)1.0;
		ImagU=(float)0.0;
		RealW=(float)cos(PI/le1);
		ImagW=(float)(-sin(PI/le1));
		for (j=1;j<=le1;j++)
		{

			s.Format("(%d)",j*2);
			m_pProg->m_staticTexte.SetWindowText(s);

	 		for (i=j;i<=*n;i=i+le)
	 		{
				i=i-1;
				ip=i+le1;

				//RealT=RealF[ip]*RealU-ImagF[ip]*ImagU;
		  	l_enreg(f_dir,ip,&e);                   
		  	RealT=e.RealF*RealU-e.ImagF*ImagU;
				
				//ImagT=RealF[ip]*ImagU+ImagF[ip]*RealU;
				ImagT=e.RealF*ImagU+e.ImagF*RealU;
				
				//RealF[ip]=RealF[i]-RealT;
		  	l_enreg(f_dir,i,&e);
		  	RealFi=e.RealF;                   
		  	ImagFi=e.ImagF;                   
        e.RealF=RealFi-RealT;
				
				//ImagF[ip]=ImagF[i]-ImagT;
        e.ImagF=ImagFi-ImagT;
		  	e_enreg(f_dir,ip,&e);
				
				//RealF[i]=RealF[i]+RealT;
				RealFi=RealFi+RealT;
				
				//ImagF[i]=ImagF[i]+ImagT;
				ImagFi=ImagFi+ImagT;
				e.RealF=RealFi;
				e.ImagF=ImagFi;
		  	e_enreg(f_dir,i,&e);
				
				i=i+1;
	 		}
	 		RealU1=RealU*RealW-ImagU*ImagW;
	 		ImagU1=RealU*ImagW+ImagU*RealW;
	 		RealU=RealU1;ImagU=ImagU1;
		}
	}
	//Affectation partie relle et imaginaire
	for (k=0;k<*n;k++)
	{
 		//Indicateur de progression
		m_pProg->m_progress.SetPos(1+nm1+ln+k);
	
	 	l_enreg(f_dir,k,&e);
		m_fT[k][0]=e.RealF;		
		m_fT[k][1]=e.ImagF;		
	} 
	fclose(f_dir);
	return TRUE;
}
//__________________________________________________
void CFft::l_enreg(FILE *f_dir,unsigned short i,struct enreg *e)
{
	fseek(f_dir,i*sizeof(*e),SEEK_SET);
	fread(e,sizeof(*e),1,f_dir);
}
//__________________________________________________
void CFft::e_enreg(FILE *f_dir,unsigned short i,struct enreg *e)
{
	fseek(f_dir,i*sizeof(*e),SEEK_SET);
	fwrite(e,sizeof(*e),1,f_dir);
}
