// FftDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "FftDlg.h"
#include "BkDoc.h"
#include "Fft.h"
#include "velodlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CFftDlg dialog
CFftDlg::CFftDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFftDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFftDlg)
	m_fInterFr = 0.0f;
	m_radioFFT = -1;
	m_sTexte = _T("");
	m_sIncr = _T("");
	m_radioVoie = -1;
	//}}AFX_DATA_INIT
}
void CFftDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFftDlg)
	DDX_Control(pDX, IDVELO, m_btnVelo);
	DDX_Control(pDX, IDCALCUL, m_btnCalcul);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Text(pDX, IDC_INTERFR, m_fInterFr);
	DDX_Radio(pDX, IDC_RADIO_FFT, m_radioFFT);
	DDX_Text(pDX, IDC_STATIC_INFO, m_sTexte);
	DDX_Text(pDX, IDC_STATIC_XINCR, m_sIncr);
	DDX_Radio(pDX, IDC_VOIE_1, m_radioVoie);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CFftDlg, CDialog)
	//{{AFX_MSG_MAP(CFftDlg)
	ON_BN_CLICKED(IDC_VOIE_1, OnVoie1)
	ON_BN_CLICKED(IDC_VOIE_2, OnVoie2)
	ON_BN_CLICKED(IDC_REF_1, OnRef1)
	ON_BN_CLICKED(IDC_REF_2, OnRef2)
	ON_BN_CLICKED(IDC_MAT, OnMat)
	ON_BN_CLICKED(IDVELO, OnVelo)
	ON_BN_CLICKED(IDCALCUL, OnCalcul)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CFftDlg message handlers
BOOL CFftDlg::OnInitDialog() 
{
	short i,j,k;
	CDialog::OnInitDialog();
	if(m_pDoc->m_iTypeGr & 1) m_radioVoie=0;
	else         
	if(m_pDoc->m_iTypeGr & 2) m_radioVoie=1;         
	else
	if(m_pDoc->m_iTypeGr & 4) m_radioVoie=2;
	else
	if(m_pDoc->m_iTypeGr & 8) m_radioVoie=3;         
	else
	if(m_pDoc->m_iTypeGr & 16) m_radioVoie=4;
	else
	{
		//Le graphe prcdent n'tait pas un graphe d'acq. mais de calcul...
		if(m_pDoc->m_iTypeAcq & 1) m_radioVoie=0;
		else         
		if(m_pDoc->m_iTypeAcq & 2) m_radioVoie=1;         
		else
		if(m_pDoc->m_iTypeAcq & 4) m_radioVoie=2;
		else
		if(m_pDoc->m_iTypeAcq & 8) m_radioVoie=3;         
		else
		if(m_pDoc->m_iTypeAcq & 16) m_radioVoie=4;
	}

	m_radioFFT=m_pDoc->m_radioFFT;
	m_fInterFr=m_pDoc->m_fInterFr;
	UpdateData(FALSE);
	MetAJour();

	if(!(m_pDoc->m_iTypeAcq & 1)) GetDlgItem(IDC_VOIE_1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 2)) GetDlgItem(IDC_VOIE_2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 4)) GetDlgItem(IDC_REF_1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 8)) GetDlgItem(IDC_REF_2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 16)) GetDlgItem(IDC_MAT)->EnableWindow(FALSE);         
	return TRUE;
}
//__________________________________________________
void CFftDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
void CFftDlg::OnVoie1() 
{
	MetAJour();
}
//__________________________________________________
void CFftDlg::OnVoie2() 
{
	MetAJour();
}
//__________________________________________________
void CFftDlg::OnRef1() 
{
	MetAJour();
}
//__________________________________________________
void CFftDlg::OnRef2() 
{
	MetAJour();
}
//__________________________________________________
void CFftDlg::OnMat() 
{
	MetAJour();
}
//__________________________________________________
void CFftDlg::MetAJour()	
{
	short i,j,k;
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&i,&j);			
	m_pDoc->m_fXincr=fabs(m_pDoc->m_fT[1][i]-m_pDoc->m_fT[0][i]);
	m_sIncr.Format("%1.3e",m_pDoc->m_fXincr);

	//Tous les points
	m_pDoc->m_iNb=0;
	for (k=0;k<m_pDoc->m_iNbMax;k++)
	{
		if (m_pDoc->m_fT[k][i]!=1e10 && m_pDoc->m_fT[k][j]!=1e10)
		{
			m_pDoc->m_iNb++;
		} 
	}
	m_sTexte.Format("Ce graphe comporte %d pts.",m_pDoc->m_iNb);

	if (m_pDoc->m_iNb<=256) m_iNbEchan=256;
	else
	if (m_pDoc->m_iNb>256 && m_pDoc->m_iNb<=512) m_iNbEchan=512;
	else
	if (m_pDoc->m_iNb>512 && m_pDoc->m_iNb<=1024) m_iNbEchan=1024;
	else
	if (m_pDoc->m_iNb>1024) m_iNbEchan=2048;

	UpdateData(FALSE);
}
//__________________________________________________
void CFftDlg::OnVelo() 
{
	UpdateData(TRUE);
	if (m_fInterFr<0.1) m_fInterFr=0.1; 
	if (m_fInterFr>1000) m_fInterFr=1000; 
	m_pDoc->m_fInterFr=m_fInterFr;
	UpdateData(FALSE);

	CVeloDlg d;
	d.m_pDoc=m_pDoc;
	d.DoModal();

}
//__________________________________________________
void CFftDlg::OnCancel() 
{
	//Initialiser le curseur souris
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	pApp->m_fDx=0;
	pApp->m_fDy=0;

	CDialog::OnCancel();
}
//__________________________________________________
void CFftDlg::OnCalcul() 
{
	//Calcul FFT
	short 
		i,j,k;
	float r,freq;

	UpdateData(TRUE);
	MetAJour();

	m_sTexte.Format("Calcul FFT en cours sur %d chantillons.\nPatientez...",m_iNbEchan);

	if (m_fInterFr<0.1) m_fInterFr=0.1; 
	if (m_fInterFr>1000) m_fInterFr=1000; 
	m_pDoc->m_fInterFr=m_fInterFr;
	UpdateData(FALSE);

	m_btnCancel.EnableWindow(FALSE);
	m_btnCalcul.EnableWindow(FALSE);
	m_btnVelo.EnableWindow(FALSE);
			
	//Tenir compte du nombre d'chantillons souhaits
	//Rajouter des valeurs nulles si le nb. d'acquisition est infrieur au nombre d'chantillons
	float (*T)[2];
	T=new float[2*m_iNbEchan][2];//Le tableau doit tre 2 fois plus grand que le nb. d'chant...
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&i,&j);			

	for (k=0;k<m_iNbEchan;k++)
	{
		T[k][0]=0;	//Partie relle
		T[k][1]=0;	//Partie imaginaire
	}
	for (k=0;k<m_pDoc->m_iNb;k++)
	{
		T[k][0]=m_pDoc->m_fT[k][j];	//Partie relle
		T[k][1]=0;	//Partie imaginaire
	}
	CFft *pFft;
	pFft=new CFft(T,&m_iNbEchan);
	pFft->CalculFft();
	m_pDoc->m_iNbEchan=m_iNbEchan;
	for (k=0;k<m_pDoc->m_iNbMax;k++)
	{
		m_pDoc->m_fT[k][4]=1e10;
		m_pDoc->m_fT[k][5]=1e10;
	}
	for (k=0;k<m_iNbEchan;k++)
	{

		freq=(float)(k/(m_iNbEchan*m_pDoc->m_fXincr));
		if (m_radioFFT==0)
		{
			//Frquence
			m_pDoc->m_fT[k][4]=freq;
		}
		else
		{
			//Vitesse
			m_pDoc->m_fT[k][4]=(float)(freq*m_fInterFr*1e-3);
		}
		//Module FFT
		m_pDoc->m_fT[k][5]=pow(pow(T[k][0],2)+pow(T[k][1],2),0.5);
	}

	delete []T;
	delete pFft;

		if (m_radioFFT==0)
			m_pDoc->m_iTypeGr=64;
		else
			m_pDoc->m_iTypeGr=128;

	//Recherche de la frquence maxi sur la premire moiti du spectre
	r=-1e10;
	i=0;
	for (k=0;k<m_iNbEchan/2;k++)
	{
		if (m_pDoc->m_fT[k][5]>r) 
		{
			r=m_pDoc->m_fT[k][5];
			i=k;
		}
	}
	freq=(float)(i/(m_iNbEchan*m_pDoc->m_fXincr));
	m_pDoc->m_fFreq=freq/1000;//En kHz
	m_pDoc->UpdateAllViews(NULL);
	m_btnCancel.EnableWindow(TRUE);
	m_btnCalcul.EnableWindow(TRUE);
	m_btnVelo.EnableWindow(TRUE);
}
