// PorSeDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "PorSeDlg.h"
#include "BkDoc.h"
#include "Tektro.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CPorSeDlg dialog
CPorSeDlg::CPorSeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPorSeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPorSeDlg)
	m_sTexte = _T("");
	m_radioPortSerie = -1;
	//}}AFX_DATA_INIT
}
void CPorSeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPorSeDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Radio(pDX, IDC_COM1, m_radioPortSerie);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPorSeDlg, CDialog)
	//{{AFX_MSG_MAP(CPorSeDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_BN_CLICKED(IDC_COM1, OnCom1)
	ON_BN_CLICKED(IDC_COM2, OnCom2)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CPorSeDlg message handlers
BOOL CPorSeDlg::OnInitDialog() 
{
	m_radioPortSerie=m_pDoc->m_radioPortSerie;
	m_pTektro=new CTektro(m_radioPortSerie);
	m_sTexte.Format("Cliquer sur Tester pour demander la version de l'appareil...");
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CPorSeDlg::OnCancel() 
{
	delete m_pTektro;
	CDialog::OnCancel();
}
//__________________________________________________
void CPorSeDlg::OnOK() 
{
	delete m_pTektro;
	UpdateData(TRUE);
	m_pDoc->m_radioPortSerie=m_radioPortSerie;
	CDialog::OnOK();
}
//__________________________________________________
void CPorSeDlg::OnTest() 
{
	UpdateData(TRUE);
	//Demande de la version de l'appareil
	m_pTektro->WriteCom("RS232:PRESET\n");
	m_pTektro->WriteCom("ID?\n");

	m_btnTest.EnableWindow(FALSE);
	m_iNb=0;SetTimer(1,10,NULL);
}
//__________________________________________________
void CPorSeDlg::OnCom1() 
{
	KillTimer(1);
	delete m_pTektro;
	UpdateData(TRUE);
	m_pTektro=new CTektro(m_radioPortSerie);
}
//__________________________________________________
void CPorSeDlg::OnCom2() 
{
	KillTimer(1);
	delete m_pTektro;
	UpdateData(TRUE);
	m_pTektro=new CTektro(m_radioPortSerie);
}
//__________________________________________________
void CPorSeDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	//Demande identification
	m_iNb++;
	if (m_iNb>20)//200 ms
	{
		KillTimer(1);
		m_btnTest.EnableWindow(TRUE);
		//On lit le buffer
		s=m_pTektro->ReadBuf();
		if (s.IsEmpty())
		{
			m_sTexte.Format("Erreur de lecture sur COM%d:9600,8,'N',1.",m_radioPortSerie+1);
			m_btnOK.EnableWindow(FALSE);
		}
		else
		{
			m_btnOK.EnableWindow(TRUE);
			m_sTexte.Format("Identification:\n%s",s);
			m_pTektro->VideBuffer();
		}
		UpdateData(FALSE);
	}		
	CDialog::OnTimer(nIDEvent);
}
